(* Ce module implante le compilateur proprement dit. *)

open Expression

(* La fonction [compile_expression e] produit un fragment de code assembleur. Ce
   code suppose que la valeur de la variable [x] se trouve dans le registre [$a0].
   Ce code doit calculer la valeur de l'expression [e] et placer cette valeur dans
   le registre [$v0]. *)

val compile_expression : expression -> unit

(* La fonction [compile e] produit un programme assembleur complet. Ce
   programme, excut  l'aide de spim, effectue une boucle: il lit une valeur
   entire sur l'entre standard; si cette valeur est nulle, le programme
   termine; si cette valeur est non nulle, alors le programme associe cette
   valeur  la variable [x], puis calcule et affiche la valeur de l'expression
   [e], et recommence. *)

val compile : expression -> unit

